/*
Copyright (C) 2009 -  Claudio Salvadori 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef CMESSAGER_H
#define CMESSAGER_H

#include <string.h>
#include <vector>
#include <iostream>

#include "IMessageDaq.h"

using namespace std;

/**
 *\file CMessager.h
 *\date  Created on: 26-apr-2009
 *\author  Author: Claudio Salvadori
 *\brief Implementation of IMessageDaq interface to devide in messages a packet
 */
/** \class CMessager
* \brief Implementation of IMessageDaq interface to devide in messages a packet*/
class CMessager: public IMessageDaq{
	public:
		/**\brief Initialize the messages maker
		*\param def 	Pointer to a stream definition structure (input)
		*\return This method return one of the possible value from s_ret \see s_ret*/
		virtual s_ret getDefinition (struct SDef def);
		
		/**\brief This method divides the packet recived into message to be formatted (the lenght of each message is
		*		the pkt_lenght defined in the xml file)
		*\param buffer_i	Pointer of the buffet to decode (input)
		*\param length_i	Length of the buffer to decode (input)
		*\param buffer_o 	Pointer to a vector of the messages to be formatted (output)
		*\return This method return one of the possible value from s_ret \see s_ret*/
		virtual s_ret retStream(unsigned char *buffer_i, unsigned long length_i, std::vector<struct SMessage> *buffer_o);

	private:
		unsigned long 	msg_Size;	/**< Size of a single message*/
};
#endif
